Module Generics
    Partial Class Complex
        Private re_ As Double
        Private im_ As Double

        Public Sub New(ByVal re As Double, ByVal im As Double)
            Me.re_ = re
            Me.im_ = im
        End Sub

        Public Property Re() As Double
            Get
                Return Me.re_
            End Get
            Set(ByVal value As Double)
                Me.re_ = value
            End Set
        End Property

        Public Property Im() As Double
            Get
                Return Me.im_
            End Get
            Set(ByVal value As Double)
                Me.im_ = value
            End Set
        End Property

        Public Overrides Function ToString() As String
            Return Me.re_.ToString() & " + " & Me.im_.ToString() & "i"
        End Function
    End Class

    Partial Class Complex
        Public Shared Operator +(ByVal lhs As Complex, ByVal rhs As Complex) As Complex
            Return New Complex(lhs.Re + rhs.Re, lhs.Im + rhs.Im)
        End Operator

        Public Shared Operator +(ByVal lhs As Double, ByVal rhs As Complex) As Complex
            Return New Complex(lhs + rhs.Re, rhs.Im)
        End Operator

        Public Shared Narrowing Operator CType(ByVal value As Complex) As Double
            Return Math.Sqrt(value.Re ^ 2 + value.Im ^ 2) ' absolute value
        End Operator

        Public Shared Widening Operator CType(ByVal value As Double) As Complex
            Return New Complex(value, 0.0)
        End Operator

        Public Shared Operator IsTrue(ByVal value As Complex) As Boolean
            Return value IsNot Nothing AndAlso (value.Re <> 0 OrElse value.Im <> 0)
        End Operator

        Public Shared Operator Not(ByVal value As Complex) As Boolean
            If value Then Return False Else Return True
        End Operator

        Public Shared Operator IsFalse(ByVal value As Complex) As Boolean
            Return Not value
        End Operator

        Public Shared Operator Or(ByVal lhs As Complex, ByVal rhs As Complex) As Complex
            If lhs Then
                Return New Complex(1.0, 1.0)
            Else
                If rhs Then
                    Return New Complex(1.0, 1.0)
                End If
            End If
            Return New Complex(0.0, 0.0)
        End Operator
    End Class

    Sub Main()
        Dim c As New Complex(0, 1)
        Dim x As Complex = 5
        If c OrElse x Then
            Console.WriteLine("x OrElse x")
        Else
            Console.WriteLine("Not (x OrElse x)")
        End If
        Console.ReadKey()
    End Sub
End Module